/*
	* Copyright (c) 2021-11 by ELECTRONIC ASSEMBLY <technik@lcd-module.de>
	*
	* WiFi Access to ESP32. Wrapper for WiFi.h
	*
	* This file is free software; you can redistribute it and/or modify
	* it under the terms of either the GNU General Public License version 2
	* or the GNU Lesser General Public License version 2.1, both as
	* published by the Free Software Foundation.
*/
#ifndef WIFI_EA_H
#define WIFI_EA_H

#define SERVERPORT 80
#define HOSTNAME "EA-ESP32-Demo" //mDNS name WiFi
#define ETHERNETHOSTNAME "EA-ESP32-Demo-ETH" //mDNS name ethernet (wired lan)

#define CONNECTION_TIMEOUT 20000


class wifi_ea
{
	public:
		void setup();
		void connectWiFi(char *ssid, char* password);
		void disconnect();
		void reconnect();
		IPAddress localIP();
		boolean isConnected();
		
		String SSID();
		String SSID(int net);
		int RSSI();
		int RSSI(int net);	
		const char* Hostname();

		int scanNetworks();
		
		void WiFiServerReceivedData();
		
		char* userSSID(){return ssid;}
		char* userPassword(){return pw;}
		bool ethernet_connected(){return eth_connected;}
		void setEthernet_connected(bool b) {eth_connected = b;}
		bool wifi_reconnect_needed(){return reconnect_needed;}
		void setWifi_reconnect_needed(bool b) {reconnect_needed = b;}
		
	
	private:
		bool eth_connected;
		bool reconnect_needed;
		byte WiFiServerReceiveBuffer[2048]; //Buffer needs to store complete ShortProtocol packet from uniTFT
		char ssid[64];
		char pw[64];	
};
#endif //#define WIFI_EA_H

extern wifi_ea WiFi_EA;

